﻿SystemOrganization addCategory: #'Neo4reSt-Traversal'!

Object subclass: #N4Traversal
	instanceVariableNames: 'startNode db returnType order relationships uniqueness pruneEvaluator returnFilter maxDepth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-Traversal'!

!N4Traversal class methodsFor: 'constants' stamp: 'mu 12/23/2011 11:51'!
builtInLanguageAssoc
	^'language' -> 'builtin'! !

!N4Traversal class methodsFor: 'constants' stamp: 'mu 12/23/2011 12:02'!
directionAllAssoc
	^'direction' -> 'all'! !

!N4Traversal class methodsFor: 'constants' stamp: 'mu 12/23/2011 12:02'!
directionInAssoc
	^'direction' -> 'in'! !

!N4Traversal class methodsFor: 'constants' stamp: 'mu 12/23/2011 12:02'!
directionOutAssoc
	^'direction' -> 'out'! !

!N4Traversal class methodsFor: 'instance creation' stamp: 'mu 1/22/2012 12:36'!
from: aNode
	^self new startNode: aNode; yourself! !

!N4Traversal class methodsFor: 'constants' stamp: 'mu 12/23/2011 11:52'!
javascriptLanguageAssoc
	^'language' -> 'javascript'! !

!N4Traversal class methodsFor: 'constants' stamp: 'mu 12/23/2011 11:55'!
nameAllAssoc
	^'name' -> 'all'! !

!N4Traversal class methodsFor: 'constants' stamp: 'mu 12/23/2011 11:56'!
nameAllButStartNodeAssoc
	^'name' -> 'all_but_start_node'! !

!N4Traversal class methodsFor: 'constants' stamp: 'mu 12/23/2011 11:55'!
nameNoneAssoc
	^'name' -> 'none'! !

!N4Traversal methodsFor: 'converting' stamp: 'mu 12/23/2011 12:45'!
asDictionary
	"order relationships uniqueness pruneEvaluator returnFilter maxDepth"
	| dict |
	dict := Dictionary new.
	self order ifNotNil: [dict at: 'order' put: self order].
	self relationships ifNotNil: [dict at: 'relationships' put: self relationships].
	self uniqueness ifNotNil: [dict at: 'uniqueness' put: self uniqueness].
	self pruneEvaluator ifNotNil: [dict at: 'pruneEvaluator' put: self pruneEvaluator].
	self returnFilter ifNotNil: [dict at: 'returnFilter' put: self returnFilter].
	self maxDepth ifNotNil: [dict at: 'maxDepth' put: self maxDepth].
	^dict! !

!N4Traversal methodsFor: 'accessing-convenient' stamp: 'mu 12/23/2011 11:20'!
breadthFirst
	self order: 'breadth_first'! !

!N4Traversal methodsFor: 'enumerating' stamp: 'mu 1/22/2012 14:42'!
collect: aBlock
	^ self traverse collect: aBlock! !

!N4Traversal methodsFor: 'accessing' stamp: 'mu 1/22/2012 12:35'!
db
	^self startNode db! !

!N4Traversal methodsFor: 'accessing-convenient' stamp: 'mu 12/23/2011 11:20'!
depthFirst
	self order: 'depth_first'! !

!N4Traversal methodsFor: 'enumerating' stamp: 'mu 1/22/2012 14:43'!
detect: aBlock ifNone: noneBlock
	^ self traverse detect: aBlock ifNone: noneBlock! !

!N4Traversal methodsFor: 'enumerating' stamp: 'mu 1/22/2012 14:32'!
do: aBlock
	^ self traverse do: aBlock! !

!N4Traversal methodsFor: 'enumerating' stamp: 'mu 1/22/2012 15:09'!
first
	^ self traverse first! !

!N4Traversal methodsFor: 'accessing-convenient' stamp: 'mu 1/22/2012 12:56'!
incoming: type
	self relIn: type! !

!N4Traversal methodsFor: 'testing' stamp: 'mu 1/22/2012 15:09'!
isEmpty
	^ self traverse isEmpty! !

!N4Traversal methodsFor: 'accessing' stamp: 'mu 12/23/2011 11:13'!
maxDepth
	"Answer the value of maxDepth"

	^ maxDepth! !

!N4Traversal methodsFor: 'accessing' stamp: 'mu 12/23/2011 11:13'!
maxDepth: anObject
	"Set the value of maxDepth"

	maxDepth := anObject! !

!N4Traversal methodsFor: 'accessing-convenient' stamp: 'mu 12/23/2011 12:08'!
noPrune
	self pruneEvaluator: (N4Dictionary with: self class builtInLanguageAssoc with: self class nameNoneAssoc)! !

!N4Traversal methodsFor: 'uniqueness' stamp: 'mu 12/23/2011 12:14'!
nodeGlobalUnique
	self uniqueness: 'node_global'! !

!N4Traversal methodsFor: 'uniqueness' stamp: 'mu 12/23/2011 12:14'!
nodePathUnique
	self uniqueness: 'node_path'! !

!N4Traversal methodsFor: 'uniqueness' stamp: 'mu 12/23/2011 12:16'!
nodeRecentUnique
	self uniqueness: 'node_recent'! !

!N4Traversal methodsFor: 'uniqueness' stamp: 'mu 12/23/2011 12:17'!
noneUnique
	self uniqueness: 'none'! !

!N4Traversal methodsFor: 'accessing' stamp: 'mu 12/23/2011 11:13'!
order
	"Answer the value of order"

	^ order! !

!N4Traversal methodsFor: 'accessing' stamp: 'mu 12/23/2011 11:13'!
order: anObject
	"Set the value of order"

	order := anObject! !

!N4Traversal methodsFor: 'accessing-convenient' stamp: 'mu 1/22/2012 12:56'!
outgoing: type
	self relOut: type! !

!N4Traversal methodsFor: 'accessing' stamp: 'mu 12/23/2011 11:13'!
pruneEvaluator
	"Answer the value of pruneEvaluator"

	^ pruneEvaluator! !

!N4Traversal methodsFor: 'accessing' stamp: 'mu 12/23/2011 11:13'!
pruneEvaluator: anObject
	"Set the value of pruneEvaluator"

	pruneEvaluator := anObject! !

!N4Traversal methodsFor: 'enumerating' stamp: 'mu 1/22/2012 14:42'!
reject: aBlock
	^ self traverse reject: aBlock! !

!N4Traversal methodsFor: 'accessing-convenient' stamp: 'mu 1/22/2012 15:55'!
relAll: type
	self relationships add: (N4Dictionary with: self class directionAllAssoc with: 'type' -> type)! !

!N4Traversal methodsFor: 'uniqueness' stamp: 'mu 12/23/2011 12:17'!
relGlobalUnique
	self uniqueness: 'relationship_global'! !

!N4Traversal methodsFor: 'accessing-convenient' stamp: 'mu 1/22/2012 15:55'!
relIn: type
	self relationships add: (N4Dictionary with: self class directionInAssoc with: 'type' -> type)! !

!N4Traversal methodsFor: 'accessing-convenient' stamp: 'mu 1/22/2012 15:55'!
relOut: type
	self relationships add: (N4Dictionary with: self class directionOutAssoc with: 'type' -> type)! !

!N4Traversal methodsFor: 'uniqueness' stamp: 'mu 12/23/2011 12:18'!
relPathUnique
	self uniqueness: 'relationship_path'! !

!N4Traversal methodsFor: 'uniqueness' stamp: 'mu 12/23/2011 12:18'!
relRecentUnique
	self uniqueness: 'relationship_recent'! !

!N4Traversal methodsFor: 'accessing' stamp: 'mu 1/22/2012 15:56'!
relationships

	^ relationships ifNil: [relationships := OrderedCollection new]! !

!N4Traversal methodsFor: 'accessing' stamp: 'mu 12/23/2011 11:13'!
relationships: anObject
	"Set the value of relationships"

	relationships := anObject! !

!N4Traversal methodsFor: 'accessing' stamp: 'mu 12/23/2011 11:13'!
returnFilter
	"Answer the value of returnFilter"

	^ returnFilter! !

!N4Traversal methodsFor: 'accessing' stamp: 'mu 12/23/2011 11:13'!
returnFilter: anObject
	"Set the value of returnFilter"

	returnFilter := anObject! !

!N4Traversal methodsFor: 'return types' stamp: 'mu 12/23/2011 11:25'!
returnFullpath
	self returnType: 'fullpath'! !

!N4Traversal methodsFor: 'return types' stamp: 'mu 12/23/2011 11:25'!
returnNode
	self returnType: 'node'! !

!N4Traversal methodsFor: 'return types' stamp: 'mu 12/23/2011 11:25'!
returnPath
	self returnType: 'path'! !

!N4Traversal methodsFor: 'return types' stamp: 'mu 12/23/2011 11:25'!
returnRelationship
	self returnType: 'relationship'! !

!N4Traversal methodsFor: 'accessing' stamp: 'mu 12/23/2011 12:40'!
returnType
	 returnType ifNil: [self returnNode].
	^returnType! !

!N4Traversal methodsFor: 'accessing' stamp: 'mu 12/23/2011 11:13'!
returnType: anObject
	"Set the value of returnType"

	returnType := anObject! !

!N4Traversal methodsFor: 'enumerating' stamp: 'mu 1/22/2012 14:42'!
select: aBlock
	^ self traverse select: aBlock! !

!N4Traversal methodsFor: 'enumerating' stamp: 'mu 1/22/2012 15:09'!
size
	^ self traverse size! !

!N4Traversal methodsFor: 'accessing' stamp: 'mu 1/22/2012 12:18'!
startNode
	"Answer the value of startNode"

	^ startNode! !

!N4Traversal methodsFor: 'accessing' stamp: 'mu 1/22/2012 12:18'!
startNode: aNode
	startNode := aNode! !

!N4Traversal methodsFor: 'actions' stamp: 'mu 1/22/2012 12:45'!
traverse
	^self traverseFrom: self startNode! !

!N4Traversal methodsFor: 'actions' stamp: 'mu 1/22/2012 13:08'!
traverseFrom: aNode
	"to do - implementing traverser"
	| json |
	json := self db restClient traverseFrom: startNode id using: self.
	^N4Traverser json: json for: self! !

!N4Traversal methodsFor: 'accessing' stamp: 'mu 12/23/2011 11:13'!
uniqueness
	"Answer the value of uniqueness"

	^ uniqueness! !

!N4Traversal methodsFor: 'accessing' stamp: 'mu 12/23/2011 11:13'!
uniqueness: anObject
	"Set the value of uniqueness"

	uniqueness := anObject! !

!N4Traversal methodsFor: 'accessing-convenient' stamp: 'mu 12/23/2011 12:05'!
wantAll
	self returnFilter: (N4Dictionary with: self class builtInLanguageAssoc with: self class nameAllAssoc) ! !

!N4Traversal methodsFor: 'accessing-convenient' stamp: 'mu 12/23/2011 12:05'!
wantAllButStartNode
	self returnFilter: (N4Dictionary with: self class builtInLanguageAssoc with: self class nameAllButStartNodeAssoc) ! !

Object subclass: #N4Traverser
	instanceVariableNames: 'traversal json index'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-Traversal'!

!N4Traverser class methodsFor: 'instance creation' stamp: 'mu 1/22/2012 13:26'!
json: jsonObject for: traversal 
	^ self new json: jsonObject;
		 traversal: traversal;
		 yourself! !

!N4Traverser methodsFor: 'accessing' stamp: 'mu 2/13/2012 00:35'!
at: anInteger
	self index: anInteger.
	^ self next! !

!N4Traverser methodsFor: 'stream-like' stamp: 'mu 1/22/2012 13:27'!
atEnd
	^self index > self json size! !

!N4Traverser methodsFor: 'enumerating' stamp: 'mu 1/22/2012 14:34'!
collect: aBlock
	| ord |
	ord := OrderedCollection new: self json size.
	[self atEnd] whileFalse: [
		ord add: (aBlock value: self next)
	].
	^ord! !

!N4Traverser methodsFor: 'accessing' stamp: 'mu 1/22/2012 15:01'!
db
	^self traversal db! !

!N4Traverser methodsFor: 'enumerating' stamp: 'mu 1/22/2012 14:41'!
detect: aBlock ifNone: noneBlock
	[self atEnd] whileFalse: [ | elem |
		(aBlock value: (elem := self next)) ifTrue: [^elem]
	].
	^noneBlock value! !

!N4Traverser methodsFor: 'enumerating' stamp: 'mu 1/22/2012 14:31'!
do: aBlock
	[self atEnd] whileFalse: [
		aBlock value: self next
	]! !

!N4Traverser methodsFor: 'accessing' stamp: 'mu 1/22/2012 15:11'!
first
	self index: 1.
	^ self next! !

!N4Traverser methodsFor: 'accessing' stamp: 'mu 1/22/2012 15:19'!
firstOrNil
	self isEmpty ifTrue: [^nil].
	^ self first! !

!N4Traverser methodsFor: 'accessing' stamp: 'mu 1/22/2012 13:25'!
index
	"Answer the value of index"

	^ index ifNil: [index := 1]! !

!N4Traverser methodsFor: 'accessing' stamp: 'mu 1/22/2012 13:24'!
index: anObject
	"Set the value of index"

	index := anObject! !

!N4Traverser methodsFor: 'testing' stamp: 'mu 1/22/2012 15:10'!
isEmpty
	^self json isEmpty! !

!N4Traverser methodsFor: 'accessing' stamp: 'mu 1/22/2012 13:25'!
json
	"Answer the value of json"

	^ json! !

!N4Traverser methodsFor: 'accessing' stamp: 'mu 1/22/2012 13:25'!
json: anObject
	"Set the value of json"

	json := anObject! !

!N4Traverser methodsFor: 'stream-like' stamp: 'mu 1/22/2012 13:28'!
next
	| parsed |
	parsed := self parse: (self json at: self index).
	self index: self index + 1.
	^parsed! !

!N4Traverser methodsFor: 'private' stamp: 'mu 1/22/2012 14:59'!
parse: jsonElement
	self returnType = 'node' ifTrue: [^(N4Node json: jsonElement) db: self db].
	self returnType = 'relationship' ifTrue: [^(N4Relationship json: jsonElement for: self startNode) db: self db].
	
	self flag: 'todo'.
	"self returnType = 'path' ifTrue: [].
	self returnType = 'fullpath' ifTrue: []."
	! !

!N4Traverser methodsFor: 'enumerating' stamp: 'mu 1/22/2012 14:42'!
reject: aBlock
	| ord |
	ord := OrderedCollection new.
	[self atEnd] whileFalse: [ | elem |
		(aBlock value: (elem := self next)) ifFalse: [ord add: elem]
	].
	^ord! !

!N4Traverser methodsFor: 'accessing' stamp: 'mu 1/22/2012 14:29'!
returnType
	^self traversal returnType! !

!N4Traverser methodsFor: 'enumerating' stamp: 'mu 1/22/2012 14:40'!
select: aBlock
	| ord |
	ord := OrderedCollection new.
	[self atEnd] whileFalse: [ | elem |
		(aBlock value: (elem := self next)) ifTrue: [ord add: elem]
	].
	^ord! !

!N4Traverser methodsFor: 'accessing' stamp: 'mu 1/22/2012 15:10'!
size
	^self json size! !

!N4Traverser methodsFor: 'accessing' stamp: 'mu 1/22/2012 15:00'!
startNode
	^self traversal startNode! !

!N4Traverser methodsFor: 'accessing' stamp: 'mu 1/22/2012 13:25'!
traversal
	"Answer the value of traversal"

	^ traversal! !

!N4Traverser methodsFor: 'accessing' stamp: 'mu 1/22/2012 13:25'!
traversal: anObject
	"Set the value of traversal"

	traversal := anObject! !
